/* FLENG - raw memory library - C part */

#include "fleng.h"
#include "fleng-util.h"
#include <stdlib.h>
#include <unistd.h>

/* terrible, terrible hack */
#if !defined(__LP64__) && !defined(_LP64)
#define fixaddr(x)  ((x) & 0x7fffffff)
#else
#define fixaddr(x)  (x)
#endif

void fl_mem_alloc_2(FL_TCB *tcb, FL_VAL size, FL_VAL var)
{
    if(((long)size & 1) != 1) fl_rt_error(tcb, size, FL_NOT_AN_INT);
    fl_assign(tcb, MKINT(malloc(INT(size))), var);
}

void fl_mem_free_2(FL_TCB *tcb, FL_VAL adr, FL_VAL done)
{
    if(((long)adr & 1) != 1) fl_rt_error(tcb, adr, FL_NOT_AN_INT);
    free((void *)fixaddr(INT(adr)));
    fl_assign(tcb, fl_nil, done);
}

void fl_mem_put_3(FL_TCB *tcb, FL_VAL adr, FL_VAL bytes, FL_VAL done)
{
    if(((long)adr & 1) != 1) fl_rt_error(tcb, adr, FL_NOT_AN_INT);
    unsigned char *p = (unsigned char *)fixaddr(INT(adr));
    if(((long)bytes & 1) == 1) *p = INT(bytes);
    else {
        while(BITS(bytes) == 0) {
            FL_VAL b = CAR(bytes);
            if(((long)b & 1) != 1) fl_rt_error(tcb, b, FL_NOT_AN_INT);
            *(p++) = INT(b);
            bytes = CDR(bytes);
        }
    }
    fl_assign(tcb, fl_nil, done);
}

void fl_mem_get_4(FL_TCB *tcb, FL_VAL adr, FL_VAL len, FL_VAL bytes, FL_VAL tail)
{
    if(((long)adr & 1) != 1) fl_rt_error(tcb, adr, FL_NOT_AN_INT);
    unsigned char *p = (unsigned char *)fixaddr(INT(adr));
    if(((long)len & 1) != 1) fl_rt_error(tcb, len, FL_NOT_AN_INT);
    int n = INT(len);
    if(n < 1) {
        fl_assign(tcb, tail, bytes);
        return;
    }
    FL_VAL lst, *prev = NULL;
    while(n-- > 0) {
        FL_VAL n = mklist(tcb, MKINT(*(p++)), fl_nil);
        if(prev == NULL) lst = n;
        else *prev = addref(n);
        prev = &CDR(n);
    }
    *prev = addref(tail);
    fl_assign(tcb, lst, bytes);
}

void fl_mem_write_4(FL_TCB *tcb, FL_VAL adr, FL_VAL len, FL_VAL fd, FL_VAL done)
{
    if(((long)adr & 1) != 1) fl_rt_error(tcb, adr, FL_NOT_AN_INT);
    unsigned char *p = (unsigned char *)fixaddr(INT(adr));
    if(((long)len & 1) != 1) fl_rt_error(tcb, len, FL_NOT_AN_INT);
    if(((long)fd & 1) != 1) fl_rt_error(tcb, fd, FL_NOT_AN_INT);
    int r = write(INT(fd), p, INT(len));
    fl_assign(tcb, MKINT(r), done);
}

void fl_mem_read_4(FL_TCB *tcb, FL_VAL adr, FL_VAL len, FL_VAL fd, FL_VAL done)
{
    if(((long)adr & 1) != 1) fl_rt_error(tcb, adr, FL_NOT_AN_INT);
    unsigned char *p = (unsigned char *)fixaddr(INT(adr));
    if(((long)len & 1) != 1) fl_rt_error(tcb, len, FL_NOT_AN_INT);
    if(((long)fd & 1) != 1) fl_rt_error(tcb, fd, FL_NOT_AN_INT);
    int r = read(INT(fd), p, INT(len));
    fl_assign(tcb, MKINT(r), done);
}
